/* $Id: CircleArea.h,v 1.4 1997/09/25 20:31:09 remek Exp $ */
/*
 * File:       CircleArea.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    Thu Apr 17 1997
 * Revision:   $Revision: 1.4 $
 * Updated:    $Date: 1997/09/25 20:31:09 $
 * Copyright 1997 NPAC, Syracuse University
 *
 */

#ifndef _CIRCLEAREA_H
#define _CIRCLEAREA_H

#include "Area.h"

class CircleArea : public Area
{
   public:
      CircleArea( const GeoPoint& ctr, const GeoPoint& mk, const string& ref );
      ~CircleArea( void );
      bool IsInside( const GeoPoint& gp );
      void dump( void );
	 
   private:
      GeoPoint center, mark;
};

inline CircleArea::
CircleArea( const GeoPoint& ctr, const GeoPoint& mk, const string& ref )
   : Area( ref ), center( ctr ), mark( mk )
{
   ACE_TRACE( "(CircleArea::CircleArea)" );
}

inline CircleArea::
~CircleArea( void )
{
   ACE_TRACE( "(CircleArea::~CircleArea)" );
}

inline bool CircleArea::
IsInside( const GeoPoint& gp )
{
   ACE_TRACE( "(CircleArea::IsInside <)" );
   return !( center.distance( mark ) < center.distance( gp ) );
}

inline void CircleArea::
dump( void )
{
   ACE_TRACE( "(CircleArea::dump)" );
   ACE_DEBUG(( LM_DEBUG, "CTR[%s] MRK[%s] ref: %s\n",
	       string( center ).c_str(),
	       string( mark ).c_str(),
	       ref().c_str() ));
}

#endif
