/* $Id: DEM.h,v 1.8 1997/09/25 20:31:46 remek Exp $ */
/*
 * File:       DEM.h
 * Author:     Remek Trzaska (remek@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.8 $
 * Updated:    $Date: 1997/09/25 20:31:46 $
 * Copyright 1996/97 NPAC, Syracuse University
 *
 */

#ifndef __DEM_H
#define __DEM_H

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <fstream.h>

#include "Global.h"
#include "WebNode.h"

////////////////////////////////////////
class DEM {

   public:
      char name[256];
      ELEV **data;
      COOR dim;

      DEM(char *aName);

      DEM(ELEV **aData, int aDim);
  
      ~DEM()
      {
	 freeMem();
      }
  
      void setData(ELEV **newData);

      virtual int read() { return 0;} ;

      void allocMem();
      void freeMem();

      virtual ELEV & operator()(int i, int j)
      { 
	 return data[i][j];
      }

      void writeRect(int xfrom, int xto, int yfrom, int yto, char *fname);

}; //DEM

////////////////////////////////////////
class PGMDEM : public DEM {

   public:

      PGMDEM(char *fname) : DEM(fname) {};
      virtual int read();

}; //PGMDEM

////////////////////////////////////////
class URLDEM : public DEM 
{
   public:
      
      URLDEM(char *url) : DEM(url) {} ;
      virtual int read();
   private:
      void processWord(WebNode& node);
      
  
}; //URLDEM

#endif
