/* $Id: GISdb.h,v 1.7 1997/09/25 20:31:47 remek Exp $ */
/*
 * File:       GISdb.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.7 $
 * Updated:    $Date: 1997/09/25 20:31:47 $
 * Copyright:  Northeast Parallel Architectures Center
 *             at Syracuse University 1997
 */

#ifndef _GISDB_H
#define _GISDB_H

#ifndef __BOOL_DEFINED
#include <bool.h>
#endif

struct CoordScale
{
      friend class GeoPoint;
      
      CoordScale( double lon_sc, double lat_sc, double alt_sc )
	 : lon_deg_size( lon_sc ), lat_deg_size( lat_sc ), alt_meter_size( alt_sc ){}
	 
      double lon_deg_size;
      double lat_deg_size;
      double alt_meter_size;
};

struct AreaInfo
{
      float lon_beg, lat_beg, lon_end, lat_end;

      bool operator== ( const AreaInfo& right_area ) const
      {
	 return lon_beg == right_area.lon_beg && lat_beg == right_area.lat_beg;
      }

      bool operator< ( const AreaInfo& right_area ) const
      {
	 return lon_beg < right_area.lon_beg ? true :
	    lat_beg < right_area.lat_beg ? true : false;
      }
};
#endif
