/* $Id: Proto.h,v 1.16 1998/02/12 20:35:43 proman Exp $ */
/*
 * File:       Proto.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.16 $
 * Updated:    $Date: 1998/02/12 20:35:43 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef __PROTO_H
#define __PROTO_H

enum Proto
{
   CAMP        = 0,  // Camera parameters chanaged
   NURL        = 1,  // Downdload new world specified by URL
   SLAY        = 2,  // Switch to specified layer
   NWRL        = 3,  // Download new world created by SceneBuilder
   SYNCR       = 4,  // Request of synchronization info
   SYNCI       = 5,  // Requested synchronization info
   QSYNC       = 6,  // Quick synch request
   DRAG        = 7,  // Dragger position change
   NEWGROUND   = 10, // Add new ground object
   NEWAIRBORNE = 11, // Add new ariborne object
   ABUPDATE    = 12, // Update airborne object
   ABMOVE      = 13, // Move airborne object
   ABSHOW      = 14, // Show airborne object
   ABHIDE      = 15, // Hide airborne object
   ABPAUSE     = 16, // Pause movement of all objects
   ABRESUME    = 17, // Resume movement of all objects
   CSUPDATE    = 18, // Classification change of moving objects
   ABFOLLOW    = 19, // Follow specified object
   ANIMATE,          // Switch animation on/off (WEATHER)
   SHOWSLICE,        // Switch to slice (WEATHER)
   SHOWISO,          // Switch on isosurface (WEATHER)
   SHOWWIND,         // Switch wind on/off (WEATHER)
   MOVEPL,           // Translate plane (WEATHER)
   ENDMARK           
};

#endif
