/* $Id: RectArea.h,v 1.6 1997/09/25 20:31:52 remek Exp $ */
/*
 * File:       RectArea.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.6 $
 * Updated:    $Date: 1997/09/25 20:31:52 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef _RECTAREA_H
#define _RECTAREA_H

#include "Area.h"
#include <algo.h>

class RectArea : public Area
{
   public:
      RectArea( const GeoPoint& ul, const GeoPoint& br, const string& ref );
      ~RectArea( void );
      bool IsInside( const GeoPoint& gp );
      void dump( void );
	 
   private:
      GeoPoint up_left, bottom_right;
};

inline RectArea::
RectArea( const GeoPoint& ul, const GeoPoint& br, const string& ref )
   : Area( ref ), up_left( ul ), bottom_right( br )
{
   ACE_TRACE( "(RectArea::RectArea)" );
}

inline RectArea::
~RectArea( void )
{
   ACE_TRACE( "(RectArea::~RectArea)" );
}

inline bool RectArea::
IsInside( const GeoPoint& gp )
{
   ACE_TRACE( "(RectArea::IsInside <)" );
   return !( up_left < gp ) && !( gp < bottom_right );
}

inline void RectArea::
dump( void )
{
   ACE_TRACE( "(RectArea::dump)" );
   ACE_DEBUG(( LM_DEBUG, "UL[%s] BR[%s] ref: %s\n",
	       string( up_left ).c_str(),
	       string( bottom_right ).c_str(),
	       ref().c_str() ));
}

#endif
