/* $Id: SceneBuilder.h,v 1.8 1997/09/25 20:31:53 remek Exp $ */
/*
 * File         : SceneBuilder.h
 * Author       : Remek Trzaska
 * Created      : Fri Jul 18 11:38:01 1997
 * Revision     : $Revision: 1.8 $
 * Updated      : $Date: 1997/09/25 20:31:53 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __SOSCENEBUILDER_H
#define __SOSCENEBUILDER_H

#include "GeoPoint.h"
#include "Global.h"
#include <Inventor/nodes/SoSelection.h>
#include <Inventor/nodes/SoInfo.h>
#include <Inventor/nodes/SoGroup.h>
#include <Inventor/nodes/SoEnvironment.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/actions/SoWriteAction.h>

const char dumpScenePath[] = "/tmp/SB_scene.iv";

class SceneBuilder
{
      GeoPoint NW;
      SoSeparator* scene;
      int degSize;
      int szLon;
      int szLat;
      int dumpScene;

   public:
      //aDegSize is number of minutes for each chunk
      SceneBuilder(GeoPoint a_NW, GeoPoint a_SE, int aDegSize = 15,
		   int aDumpScene = FALSE);
      SceneBuilder(GeoPoint a_NW, int aSzLon, int aSzLat, int aDegSize = 15,
		   int aDumpScene = FALSE);

      SoSeparator* getScene() { return scene; }
      static void init();
      
   private:
      void build();
      void putGISTag(SoGroup* parent, const char* tag, const char* tagVal);
      void putTerrains();
      void putTextures();
};

inline SceneBuilder::
SceneBuilder(GeoPoint a_NW, int aSzLon, int aSzLat, int aDegSize,
	     int aDumpScene) :
   NW(a_NW), szLon(aSzLon), szLat(aSzLat),
   degSize(aDegSize), dumpScene(aDumpScene)
{
   build();
};

#endif

