/* $Id: SoActiveTranslation.C,v 1.5 1997/09/25 20:31:53 remek Exp $ */
/*
 * File         : SoActiveTranslation.C
 * Author       : Pawel Roman
 * Created      : Mon Aug 25 14:26:53 1997
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1997/09/25 20:31:53 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "SoActiveTranslation.h"

SoActiveTranslation::
SoActiveTranslation( void )
   : alpha( new SoOneShot ), inter( new SoInterpolateVec3f ), intStatus( 0 )
{
   ACE_TRACE( "(SoActiveTranslation::SoActiveTranslation)" );
   if( ! alpha )
   {
      ACE_ERROR(( LM_ERROR,
		  "[!](SoActiveTranslation::SoActiveTranslation) alpha not allocated\n" ));
      return;
   }
   if( ! inter )
   {
      ACE_ERROR(( LM_ERROR,
		  "[!](SoActiveTranslation::SoActiveTranslation) inter not allocated\n" ));
      return;
   }
   TRACE_REF( alpha );
   TRACE_REF( inter );
   alpha->flags = SoOneShot::HOLD_FINAL;
   inter->alpha.connectFrom( &alpha->ramp );
   translation.connectFrom( &inter->output );
   intStatus = 1;
}
