/*
 * File         : SoIsosurface.h
 * Author       : Remek Trzaska
 * Created      : Mon Feb  9 12:56:38 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/02/12 17:24:39 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#ifndef __SOISOSURFACE_H
#define __SOISOSURFACE_H

#include <Inventor/nodes/SoSeparator.h>
#include "vtmcP.h"

class SoIsosurface: public SoSeparator
{
   public:
      SoIsosurface();
      SoIsosurface(float *aData, int aSizeX, int aSizeY, int aSizeZ, 
		   float aThreshold, float aDeltaX=1.0,
		   float aDeltaY=1.0, float aDeltaZ=1.0);
      virtual ~SoIsosurface();
      
   private:
      float* grid;
      float threshold;
      int sizeX;
      int sizeY;
      int sizeZ;
      float deltaX;
      float deltaY;
      float deltaZ;
      
      void doTheJob();
      
};


#endif

