/* $Id: SoPlaneable.h,v 1.3 1998/02/12 17:26:53 remek Exp $ */
//
// File:       <SoPlaneable.h>
// Author:     <Remigiusz Trzaska>
// e-mail:     <remek@npac.syr.edu>
// Created:    <Wed Jan 15 1997>
// Time-stamp: <97/01/16 10:06:28 remek>
//
// Description: 
//   An Inventor node without appearance, can be shifted in three
//   directions

#ifndef _SOPLAENABLE_HH
#define _SOPLAENABLE_HH

#include <Inventor/draggers/SoTranslate1Dragger.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoRotation.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTranslation.h>

class SoXtWebViewer;


class SoPlaneable: public SoSeparator {
   public:
      float deltaX, deltaY, deltaZ; // the distance between samples
      SoTranslation* translation;
      enum Mode {
	 XZ = 0x01, // horizontal
	 XY = 0x02, // vertical (in eye-to-monitor direction)
	 YZ = 0x04 // vertical (in monitor screen direction)
      };
      
      SoPlaneable();
      SoPlaneable(int aSizeX,
		  int aSizeY,
		  int aSizeZ,
		  SoXtWebViewer* aViewer,
		  int aMode = XZ,
		  float aDeltaX=1.0, float aDeltaY=1.0, float aDeltaZ=1.0);
      virtual ~SoPlaneable();

      void setMode(int aMode);
      void setDelta(float aDeltaX, float aDeltaY, float aDeltaZ) {
	 deltaX = aDeltaX;
	 deltaY = aDeltaY;
	 deltaZ = aDeltaZ;
	 construct();
      }
      void setCurrentX(float newX);    
      void setCurrentY(float newY);
      void setCurrentZ(float newZ);
      int getSizeX() { return sizeX;}
      int getSizeY() { return sizeY;}
      int getSizeZ() { return sizeZ;}
      int getMode() { return mode;}
      void construct();
      void moveYourself(float newCoor);

   protected:
      int mode;
      float currX, currY, currZ;
      int sizeX, sizeY, sizeZ; 

      virtual void constructContent() = 0;
      virtual void updateValues() = 0;
      void addHandles();

   private:
      SoTranslate1Dragger* draggers[4];
      SoTranslate1Dragger* addHandle(int widthDelta, int heightDelta);
      SoXtWebViewer* viewer;
}
;

#endif
