/* $Id: SoURLTexture2.C,v 1.14 1997/09/25 20:31:58 remek Exp $ */
/*
 * File:       SoURLTexture2.C
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.14 $
 * Updated:    $Date: 1997/09/25 20:31:58 $
 * Copyright 1996/97 NPAC, Syracuse University
 *
 */

#include "SoURLTexture2.h"
#include "SoChunk.h"

SoURLTexture2::
SoURLTexture2( char* url, SoGroup* aParent, SoNode* aChildToReplace,
	       int rotate )
   : parent(aParent), childToReplace(aChildToReplace)
{
   ACE_TRACE( "(SoURLTexture2::SoURLTexture2)" );
   //check the extension
   char* extension = strrchr( url, '.' );
   if(( extension[1] == 't' && extension[2]=='w' && extension[3]=='v') ||
      ( extension[1] == 'p' && extension[2]=='p' && extension[3]=='m'))
   {
      WebNode* wnode;
      TRACE_NEW_2( wnode, WebNode( url,
				   ( WebNode::CallbackFunc* )texFetchedCB,
				   this,
				   rotate ) );
      if( ! wnode )
	 ACE_ERROR(( LM_ERROR, "[!](SoURLTexture2::SoURLTexture2) No memory for wnode\n" ));
   }
   else
   {
      ACE_ERROR(( LM_ERROR, "[!](SoURLTexture2::SoURLTexture2) Unknown file type: %s",
		  url ));
      
      TRACE_NEW_2(data_, unsigned char[2*2*3]);
      if( ! data_ )
      {
	 ACE_ERROR(( LM_ERROR, "[!](SoURLTexture2::SoURLTexture2) No memory for data_\n" ));
	 return;
      }
      for(int i=0; i<2*2*3; data_[i++] = 128)
	 ;
      
      image.setValue(SbVec2s(2, 2), 3, data_);
   }
}


SoURLTexture2::
~SoURLTexture2()
{
   ACE_TRACE( "(SoURLTexture2::~SoURLTexture2)" );
   TRACE_DELETE_TAB( data_ );
   ACE_DEBUG(( LM_DEBUG, "this=0x%x, ref=%d\n", this, getRefCount() ));
}

void SoURLTexture2::
texFetchedCB( WebNode* wn, SoURLTexture2* tex )
{
   ACE_TRACE( "(SoURLTexture2::texFetchedCB)" );
   if( ! *wn )
      ACE_ERROR(( LM_ERROR, "[!](SoURLTexture2::texFetchedCB) WebNode error: %s\n",
		  wn->getErrMsg() ));
   else
   {
      //format was ok
      tex->data_ = (unsigned char *)wn->getBuffer();
      tex->dim_ = tex->data_[0] * 256 + tex->data_[1];
      tex->image.setValue(SbVec2s(tex->dim_, tex->dim_), 3, tex->data_+2);
      tex->parent->replaceChild( tex->childToReplace, tex );
   }
   TRACE_DELETE( wn );
}
