/*
 * File         : SoVectors.h
 * Author       : Remek Trzaska
 * Created      : Wed Dec 17 14:14:48 1997
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/12 17:27:02 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __SOVECTORS_H
#define __SOVECTORS_H

#include "SoPlaneable.h"
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoIndexedLineSet.h>

class SoVectors: public SoPlaneable 
{
      float* dataU;
      float* dataV;
      float* dataW;
      float maxLength;
      float normalRatio;
      
   public:
      SoVectors();
      SoVectors(float* aDataU, float* aDataV, float* aDataW,
		int aSizeX, int aSizeY, int aSizeZ,
		SoXtWebViewer* viewer,
		int mode = XZ,
		float aDeltaX = 1.0, float aDeltaY = 1.0, float aDeltaZ = 1.0);
      virtual ~SoVectors();
      void setData(float* aDataU, float* aDataV, float* aDataW,
 		   int aSizeX, int aSizeY, int aSizeZ);

   protected:
      virtual void constructContent();
      virtual void updateValues();

   private:
      SoCoordinate3* coor;
      void setCoordinates();
      void findMinMax();
      void copyArray(float* &dest, float* source);
      SbVec3f arrow(int x, int y, int z);
};

#endif

