/* $Id: SoXtDBInfoList.C,v 1.5 1997/09/25 20:31:59 remek Exp $ */
/*
 * File:       SoXtDBInfoList.C
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    Thu May  8 1997
 * Revision:   $Revision: 1.5 $
 * Updated:    $Date: 1997/09/25 20:31:59 $
 * Copyright Pawel Roman 1997 NPAC, Syracuse University
 *
 */

#include "SoXtDBInfoList.h"

#include "SoXtDBInfoList.h"
#include "SoXtWebViewer.h"

#include <Xm/DialogS.h>
#include <Xm/BulletinB.h>

SoXtDBInfoList::
SoXtDBInfoList( const vector<string>& movos,
		SoXtWebViewer* vw,
		Widget parent,
		const char* name,
		SbBool buildInsideParent )
   : SoXtComponent( parent, name, buildInsideParent ), viewer( vw )
{
   ACE_TRACE( "(SoXtDBInfoList::SoXtDBInfoList)" );
   int nCount = movos.size();
   XmStringTable str_list;
   if( nCount != 0 )
      str_list = ( XmStringTable )XtMalloc( nCount * sizeof ( XmString* ) );
   else
      str_list = NULL;
   
   for( int i=0; i < nCount; i++ )
      str_list[i] = XmStringCreateSimple( ( char* )movos[i].c_str() );
   
   Arg args[6];
   XtSetArg( args[0], XmNallowShellResize, True );
   Widget shell = XmCreateDialogShell( parent, "dbInfoList", args, 1 );

   XmString dialogTitle = XmStringCreateSimple( "Database Info List" );
   XtSetArg( args[0], XmNdefaultPosition, False );
   XtSetArg( args[1], XmNnoResize, True );
   XtSetArg( args[2], XmNdialogTitle, dialogTitle );
   manager = XmCreateBulletinBoard( shell, "BBoard", args, 3 );
   XtAddCallback( manager, XmNmapCallback, ( XtCallbackProc )mapCB, parent );
   XmStringFree( dialogTitle );
   
   
   Dimension w;
   XtVaGetValues( parent, XmNwidth, &w, NULL );
   XtSetArg( args[0], XmNvisibleItemCount, 4 );
   XtSetArg( args[1], XmNitemCount, nCount );
   XtSetArg( args[2], XmNitems, str_list );
   XtSetArg( args[3], XmNlistSizePolicy, XmCONSTANT );
   XtSetArg( args[4], XmNscrollBarDisplayPolicy, XmSTATIC );
   XtSetArg( args[5], XmNwidth, w-21 );
   list = XmCreateScrolledList( manager, "DBInfoList", args, 6 );
   XtManageChild( list );
   XtAddCallback( list, XmNdefaultActionCallback, ( XtCallbackProc )selectedCB, this );

   for( i=0; i<nCount; i++ )
      XmStringFree( str_list[i] );

   if( nCount != 0 )
      XtFree( ( char* )str_list );
}

void SoXtDBInfoList::
mapCB( Widget dialog, Widget adj_widget )
{
   ACE_TRACE( "(SoXtDBInfoList::mapCB)" );
   static const int dFrameWidth = 40;
   Position x, y;
   Dimension h, w;
   
   XtVaGetValues( adj_widget,
		  XmNx, &x,
		  XmNy, &y,
		  XmNheight, &h,
		  XmNwidth, &w,
		  NULL );
   
   XtVaSetValues( dialog,
		  XmNx, x,
		  XmNy, y+h+dFrameWidth,
//		  XmNwidth, w,
//		  XmNresizePolicy, XmRESIZE_NONE,
		  NULL );

   ACE_DEBUG(( LM_DEBUG, "x=%d, y=%d, w=%d, y+h+f=%d\n", x, y, w, y+h+dFrameWidth ));
}

void SoXtDBInfoList::
selectedCB( Widget /*list*/,
	    SoXtDBInfoList* pList,
	    XmListCallbackStruct* cbs )
{
   ACE_TRACE( "(SoXtDBInfoList::selectedCB)" );
   pList->hide();
   cbs;
   ACE_DEBUG(( LM_DEBUG, "Selected no. %d\n", cbs->item_position ) );
}

