/* $Id: SoXtDBInfoList.h,v 1.5 1997/09/25 20:32:00 remek Exp $ */
/*
 * File:       SoXtDBInfoList.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.5 $
 * Updated:    $Date: 1997/09/25 20:32:00 $
 * Copyright Pawel Roman 1996/7 NPAC, Syracuse University
 *
 */

#ifndef _SOXTDBLIST_H
#define _SOXTDBLIST_H

#include <STL/stlstring.h>
#include <Inventor/Xt/SoXtComponent.h>
#include <Xm/Xm.h>
#include <Xm/List.h>

#include "Comm.h"

class SoXtWebViewer;

class SoXtDBInfoList : public SoXtComponent
{
   public:
      SoXtDBInfoList( const vector<string>& dbs,
		     SoXtWebViewer* vw,
		     Widget parent = NULL,
		     const char* name = NULL,
		     SbBool buildInsideParent = TRUE );

      ~SoXtDBInfoList( void );
      void show( void );
      void hide( void );
      void add( const string& dbID );
	 
   private:
      static void mapCB( Widget dialog, Widget adj_widget );
      static void selectedCB( Widget list, SoXtDBInfoList* pLList, XmListCallbackStruct* cbs );
      
      Widget manager;
      Widget list;
      SoXtWebViewer* viewer;
};

inline SoXtDBInfoList::
~SoXtDBInfoList( void )
{
   ACE_TRACE( "(SoXtDBInfoList::~SoXtDBInfoList)" );
   XtDestroyWidget( XtParent( manager ) );
}

inline void SoXtDBInfoList::
show( void )
{
   ACE_TRACE( "(SoXtDBInfoList::show)" );
   XtManageChild( manager );
   XtPopup( XtParent( manager ), XtGrabNone );
}

inline void SoXtDBInfoList::
hide( void )
{
   ACE_TRACE( "(SoXtDBInfoList::hide)" );
   XtUnmanageChild( manager );
   XtPopdown( XtParent( manager ) );
}

inline void SoXtDBInfoList::
add( const string& dbID )
{
   ACE_TRACE( "(SoXtDBInfoList::add)" );
   XmString dbID_xmstr = XmStringCreateSimple( ( char* )dbID.c_str() );
   XmListAddItemUnselected( list, dbID_xmstr, 1 );
   XmStringFree( dbID_xmstr );
}

#endif
