/* $Id: SoXtLayerList.h,v 1.9 1997/09/25 20:32:00 remek Exp $ */
/*
 * File:       SoXtLayerList.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.9 $
 * Updated:    $Date: 1997/09/25 20:32:00 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef _SOXTLAYERLIST_H
#define _SOXTLAYERLIST_H

#include <STL/stlstring.h>
#include <Inventor/Xt/SoXtComponent.h>
#include <Xm/Xm.h>

#include "Comm.h"

class SoXtWebViewer;

class SoXtLayerList : public SoXtComponent
{
   public:
      SoXtLayerList( const vector<string>& layers,
		     SoXtWebViewer* vw,
		     Widget parent = NULL,
		     const char* name = NULL,
		     SbBool buildInsideParent = TRUE );

      ~SoXtLayerList( void );
      void show( void );
      void hide( void );
      
   private:
      static void mapCB( Widget dialog, Widget adj_widget );
      static void selectedCB( Widget list, SoXtLayerList* pLList, XmListCallbackStruct* cbs );
      
      Widget manager;
      SoXtWebViewer* viewer;
};

inline SoXtLayerList::
~SoXtLayerList( void )
{
   ACE_TRACE( "(SoXtLayerList::~SoXtLayerList)" );
   XtDestroyWidget( XtParent( manager ) );
}

inline void SoXtLayerList::
show( void )
{
   ACE_TRACE( "(SoXtLayerList::show)" );
   XtManageChild( manager );
   XtPopup( XtParent( manager ), XtGrabNone );
}

inline void SoXtLayerList::
hide( void )
{
   ACE_TRACE( "(SoXtLayerList::hide)" );
   XtUnmanageChild( manager );
   XtPopdown( XtParent( manager ) );
}

#endif
