/* $Id: SoXtMovoList.C,v 1.2 1997/09/25 20:32:01 remek Exp $ */
/*
 * File:       SoXtMovoList.C
 * Author:     $Author: remek $
 * Created:    Thu May  8 1997
 * Revision:   $Revision: 1.2 $
 * Updated:    $Date: 1997/09/25 20:32:01 $
 * Copyright Pawel Roman 1997 NPAC, Syracuse University
 *
 */

#include "SoXtMovoList.h"

#include "SoXtMovoList.h"
#include "SoXtWebViewer.h"

#include <Xm/DialogS.h>
#include <Xm/BulletinB.h>

SoXtMovoList::
SoXtMovoList( const vector<string>& movos,
	       SoXtWebViewer* vw,
	       Widget parent,
	       const char* name,
	       SbBool buildInsideParent )
   : SoXtComponent( parent, name, buildInsideParent ), viewer( vw )
{
   ACE_TRACE( "(SoXtMovoList::SoXtMovoList)" );
   int nCount = movos.size();
   XmStringTable str_list;
   if( nCount != 0 )
      str_list = ( XmStringTable )XtMalloc( nCount * sizeof ( XmString* ) );
   else
      str_list = NULL;
   
   for( int i=0; i < nCount; i++ )
      str_list[i] = XmStringCreateSimple( ( char* )movos[i].c_str() );
   
   Arg args[2];
   XtSetArg( args[0], XmNallowShellResize, True );
   Widget shell = XmCreateDialogShell( parent, "Follow", args, 1 );
   XtSetArg( args[0], XmNdefaultPosition, False );
   XtSetArg( args[1], XmNnoResize, True );
   manager = XmCreateBulletinBoard( shell, "BBoard", args, 2 );
   XtAddCallback( manager, XmNmapCallback, ( XtCallbackProc )mapCB, parent );
   list = XtVaCreateManagedWidget( "MovoList",
				   xmListWidgetClass, manager,
				   XmNvisibleItemCount, nCount,
				   XmNitemCount, nCount,
				   XmNitems, str_list,
				   NULL );
   XtAddCallback( list, XmNdefaultActionCallback, ( XtCallbackProc )selectedCB, this );
   for( i=0; i<nCount; i++ )
      XmStringFree( str_list[i] );

   if( nCount != 0 )
      XtFree( ( char* )str_list );
}

void SoXtMovoList::
mapCB( Widget dialog, Widget adj_widget )
{
   ACE_TRACE( "(SoXtMovoList::mapCB)" );
   static const int dFrameWidth = 15;
   Position x, y;
   Dimension w;
   
   XtVaGetValues( adj_widget, XmNx, &x, XmNy, &y, NULL );
   XtVaGetValues( dialog, XmNwidth, &w, NULL );
   XtVaSetValues( dialog, XmNx, x-w-dFrameWidth, XmNy, y, NULL );
   ACE_DEBUG(( LM_DEBUG, "x=%d, y=%d, w=%d, x-w=%d\n", x, y, w, x-w-dFrameWidth ));
}

void SoXtMovoList::
selectedCB( Widget /*list*/,
	    SoXtMovoList* pLList,
	    XmListCallbackStruct* cbs )
{
   ACE_TRACE( "(SoXtMovoList::selectedCB)" );
   pLList->hide();
   ACE_DEBUG(( LM_DEBUG, "Selected no. %d\n", cbs->item_position ) );
   char* movoID;
   XmStringGetLtoR( cbs->item, XmSTRING_DEFAULT_CHARSET, &movoID );
   pLList->viewer->followMovo( string( movoID ) );
   XtFree( movoID );
}

