/* $Id: SoXtMovoList.h,v 1.2 1997/09/25 20:32:01 remek Exp $ */
/*
 * File:       SoXtMovoList.h
 * Author:     $Author: remek $
 * Created:    long time ago
 * Revision:   $Revision: 1.2 $
 * Updated:    $Date: 1997/09/25 20:32:01 $
 * Copyright Pawel Roman 1996/7 NPAC, Syracuse University
 *
 */

#ifndef _SOXTMOVOLIST_H
#define _SOXTMOVOLIST_H

#include <stlstring.h>
#include <Inventor/Xt/SoXtComponent.h>
#include <Xm/Xm.h>
#include <Xm/List.h>

#include "Comm.h"

class SoXtWebViewer;

class SoXtMovoList : public SoXtComponent
{
   public:
      SoXtMovoList( const vector<string>& movos,
		     SoXtWebViewer* vw,
		     Widget parent = NULL,
		     const char* name = NULL,
		     SbBool buildInsideParent = TRUE );

      ~SoXtMovoList( void );
      void show( void );
      void hide( void );
      void add( const string& movoID );
      void clear( void );

   private:
      static void mapCB( Widget dialog, Widget adj_widget );
      static void selectedCB( Widget list, SoXtMovoList* pLList, XmListCallbackStruct* cbs );
      
      Widget manager;
      Widget list;
      SoXtWebViewer* viewer;
};

inline SoXtMovoList::
~SoXtMovoList( void )
{
   ACE_TRACE( "(SoXtMovoList::~SoXtMovoList)" );
   XtDestroyWidget( XtParent( manager ) );
}

inline void SoXtMovoList::
show( void )
{
   ACE_TRACE( "(SoXtMovoList::show)" );
   XtManageChild( manager );
   XtPopup( XtParent( manager ), XtGrabNone );
}

inline void SoXtMovoList::
hide( void )
{
   ACE_TRACE( "(SoXtMovoList::hide)" );
   XtUnmanageChild( manager );
   XtPopdown( XtParent( manager ) );
}

inline void SoXtMovoList::
add( const string& movoID )
{
   ACE_TRACE( "(SoXtMovoList::add)" );
   XmString movoID_xmstr = XmStringCreateSimple( ( char* )movoID.c_str() );
   XmListAddItemUnselected( list, movoID_xmstr, 0 );
   XmStringFree( movoID_xmstr );
   int numItems;
   XtVaGetValues( list, XmNitemCount, &numItems, NULL );
   XtVaSetValues( list, XmNvisibleItemCount, numItems, NULL );
}

inline void SoXtMovoList::
clear( void )
{
   ACE_TRACE( "(SoXtMovoList::clear)" );
   hide();
   XmListDeleteAllItems( list );
}

#endif
