/* $Id: SoXtOLDialog.C,v 1.17 1998/04/23 20:13:37 remek Exp $ */
/*
 * File:       SoXtOLDialog.C
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.17 $
 * Updated:    $Date: 1998/04/23 20:13:37 $
 * Copyright 1996/97 NPAC, Syracuse University
 *
 */

#include "SoXtOLDialog.h"
#include "SoXtWebViewer.h"

#include <iostream.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoWWWInline.h>

static const char DEFAULT_URL[]="http://dagger.npac.syr.edu:80/GIS/biggest.wrl";

SoXtOLDialog::
SoXtOLDialog( SoXtWebViewer* viewer,
	      Widget parent,
	      const char* name,
	      SbBool buildInsideParent )
   : SoXtComponent( parent, name, buildInsideParent )
{
   ACE_TRACE( "(SoXtOLDialog::SoXtOLDialog)" );
   Arg args[6];
   int nArgs = 0;
   XmString string = XmStringCreateSimple( "Open" );
   XtSetArg( args[nArgs], XmNokLabelString, string ); nArgs++;
   XmString string2 = XmStringCreateSimple( "Open Location:" );
   XtSetArg( args[nArgs], XmNselectionLabelString,string2); nArgs++;
   XmString string3 = XmStringCreateSimple( ( char* )DEFAULT_URL );
   XtSetArg( args[nArgs], XmNtextString, string3 ); nArgs++;
   XtSetArg( args[nArgs], XmNwidth, DIALOG_WIDTH ); nArgs++;
   XtSetArg( args[nArgs], XmNautoUnmanage, TRUE ); nArgs++;
   XmString string4 = XmStringCreateSimple( "Open Location" );
   XtSetArg( args[nArgs], XmNdialogTitle, string4 ); nArgs++;
   locationDialog = XmCreatePromptDialog( parent, "OpenLocation", args, nArgs );

   Widget w = XmSelectionBoxGetChild( locationDialog, XmDIALOG_HELP_BUTTON );
   XtUnmanageChild( w );
     
   XtAddCallback( locationDialog, XmNokCallback, ( XtCallbackProc )OpenLocationCB, viewer );
   XmStringFree( string );
   XmStringFree( string2 );
   XmStringFree( string3 );
   XmStringFree( string4 );
   setBaseWidget( locationDialog );
   setIconTitle( "" );
}

void SoXtOLDialog::
OpenLocationCB( Widget,
		SoXtWebViewer* viewer, 
		XmSelectionBoxCallbackStruct* cbs )
{
   ACE_TRACE( "(SoXtOLDialog::OpenLocationCB)" );
   char* text;
   if( XmStringGetLtoR( cbs->value, XmSTRING_DEFAULT_CHARSET, &text ) )
   {
      if( *text )
      {
	 if( strncmp( text, "http://", 7 ) && strncmp( text, "file:", 5 ) )
	 {
	    char fullURL[1024];
	    strcpy( fullURL, "http://" );
	    strcat( fullURL, text );
	    text = fullURL;
	 }
	 viewer->loadNewGraph( text );
      }
      else
      {
	 SoXt::createSimpleErrorDialog( viewer->getWidget(),
					"Uniform Resource Locator Error", "Empty URL",
					"Enter string like: http://mordillo.npac.syr.edu:8888/VRML/city.wrl");
	 ACE_ERROR(( LM_ERROR,
		     "[!](%P)(SoXtOLDialog::OpenLocationCB) Empty URL specified\n" ));
      }
      XtFree( text );
   }
   else 
   {
      SoXt::createSimpleErrorDialog( viewer->getWidget(), "XmString error", "Conversion error" );
      ACE_ERROR(( LM_ERROR,
		  "[!](%P)(SoXtOLDialog::OpenLocationCB) XmString error\n" ));
   }
}
