/* $Id: SoXtVariableList.h,v 1.2 1998/02/12 02:31:33 remek Exp $ */
/*
 * File:       SoXtVariableList.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.2 $
 * Updated:    $Date: 1998/02/12 02:31:33 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef _SOXTVARIABLELIST_H
#define _SOXTVARIABLELIST_H

#include <STL/stlstring.h>
#include <Inventor/Xt/SoXtComponent.h>
#include <Xm/Xm.h>

#include "Comm.h"

class SoXtWebViewer;

class SoXtVariableList : public SoXtComponent
{
   public:
      SoXtVariableList( const vector<string>& layers,
		     SoXtWebViewer* vw,
		     Widget parent = NULL,
		     const char* name = NULL,
		     SbBool buildInsideParent = TRUE );

      virtual ~SoXtVariableList( void );
      void show( void );
      void hide( void );
      virtual void performAction(SoXtVariableList* vlist, int index) = 0;
      
   private:
      static void mapCB( Widget dialog, Widget adj_widget );
      static void selectedCB( Widget list, SoXtVariableList* pLList, XmListCallbackStruct* cbs );
      
      Widget manager;

   public:
      SoXtWebViewer* viewer;
};

inline void SoXtVariableList::
show( void )
{
   ACE_TRACE( "(SoXtVariableList::show)" );
   XtManageChild( manager );
   XtPopup( XtParent( manager ), XtGrabNone );
}

inline void SoXtVariableList::
hide( void )
{
   ACE_TRACE( "(SoXtVariableList::hide)" );
   XtUnmanageChild( manager );
   XtPopdown( XtParent( manager ) );
}

#endif
