/* $Id: StringRepos.C,v 1.6 1997/09/25 20:32:03 remek Exp $ */
/*
 * File:       StringRepos.C
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.6 $
 * Updated:    $Date: 1997/09/25 20:32:03 $
 * Copyright 1996/97 NPAC, Syracuse University
 *
 */

#include "Comm.h"
#include "StringRepos.h"

#include <stdlib.h>
#include <string.h>
#include <iostream.h>

StringRep::StringRep( int newSize )
{
   ptr = 0;
   size = newSize;
   TRACE_NEW_2( rep, char*[size] );
   if( ! rep )
   {
      cerr << "StringRep: No memory for rep\n";
      exit (1);
   }
}

StringRep::~StringRep()
{
   while( ptr )
   {
      --ptr;
      TRACE_DELETE_TAB( rep[ptr] );
   }
   TRACE_DELETE_TAB( rep );
}

bool StringRep::add( const char* str )
{
   if( ptr == size )
      return 0;
   int slen = strlen( str )+1;
   TRACE_NEW_2 ( rep[ptr], char[slen] );
   if( ! rep[ptr] )
   {
      cerr << "StringRep::add: No memory for new str\n";
      exit(1);
   }
   strcpy( rep[ptr], str );
   return ++ptr;
}

bool StringRep::search( register const char* str ) const
{
   for( register int i=ptr-1; i>-1; i-- )
   {
      if( ! strcmp( rep[i], str ) )
	 return 1;
   }
   return 0;
}
