/* $Id: TagParser.h,v 1.6 1997/09/25 20:32:05 remek Exp $ */
/*
 * File:       TagParser.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.6 $
 * Updated:    $Date: 1997/09/25 20:32:05 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef _TAGPARSER_H
#define _TAGPARSER_H

#include "Comm.h"
#include <Inventor/SoLists.h>

const char TOKEN_SEPARATOR = ',';

class SoXtWebViewer;
typedef int TagActionCB( SoNodeList&, SoXtWebViewer& );

struct TagAction
{
      char* tag;
      TagActionCB* action;
};

class TagParser
{
   public:
      TagParser( SoXtWebViewer& vw );
      int parse( void );
      
   private:
      static const TagAction tags[];
      SoXtWebViewer& viewer;
};

inline TagParser::
TagParser( SoXtWebViewer& vw )
   : viewer( vw )
{
   ACE_TRACE( "(TagParser::TagParser)" );
   parse();
}

#endif
