/* $Id: Timer.h,v 1.6 1997/09/25 20:32:05 remek Exp $ */
/*
 * File:       Timer.h
 * Author:     Remek Trzaska (remek@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.6 $
 * Updated:    $Date: 1997/09/25 20:32:05 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef TIMER_H
#define TIMER_H

#ifdef DEBUG

#include <stdio.h>
#include <sys/time.h>

class Timer
{
      time_t startSec;
      long startUSec;
  
   public:
      Timer( void ) { reset(); }
      void stop( char* );
      void reset( void );
};

inline void Timer::
stop( char* message )
{
   timeval t;
    
   gettimeofday(&t);
    
   float passedSec = t.tv_sec - startSec;
   float passedUSec = (t.tv_usec - startUSec)/1000000.0;
   printf("%s: %f\n", message, passedSec + passedUSec);
}

void Timer::
reset( void )
{
   timeval t;
   gettimeofday(&t);
   startSec = t.tv_sec;
   startUSec = t.tv_usec;
}

#else /* ~DEBUG*/

class Timer
{
   public:
      Timer( void ) {}
      void stop( char* ) {};
      void reset( void ) {};
};
      
#endif /*DEBUG*/

#endif /*TIMER_H*/
