/* $Id: URL.C,v 1.8 1997/09/25 20:32:06 remek Exp $ */
/*
 * File:       URL.C
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.8 $
 * Updated:    $Date: 1997/09/25 20:32:06 $
 * Copyright 1996/97 NPAC, Syracuse University
 *
 */

#include "URL.h"

// http://www.construct.net:80/worlds/nutmeg.wrl
static const char FILE_PREFIX[] = "file://";
static const char HTTP_PREFIX[] = "http://";

int URL::
setURL( const char* newURL )
{
   ACE_TRACE( "(URL::setURL)" );

   int nBeg = 0;
   int nEnd;

   if( ! strncmp( newURL, FILE_PREFIX, sizeof FILE_PREFIX-1 ) )
   {
      nEnd = strcspn( newURL, ":" );
      sb_prefix = SbString( newURL, nBeg, nEnd+2 );
      sb_resource = SbString( newURL+nEnd+3 );
      ACE_DEBUG(( LM_DEBUG, "prefix: %s\nresource: %s\n",
		  sb_prefix.getString(),
		  sb_resource.getString() ));
      return 1;
   }

   if( strncmp( newURL, HTTP_PREFIX, sizeof HTTP_PREFIX-1 )||
       ! strchr( strstr( newURL, "://" )+3, '/' ) )
      ACE_ERROR_RETURN(( LM_ERROR, "[!](URL::setURL) Invalid URL\n" ), 0 );

   nEnd = strcspn( newURL, ":" );
   sb_prefix = SbString( newURL, nBeg, nEnd+2 );

   nBeg = nEnd + 3;
   nEnd = nBeg + strcspn( newURL+nBeg, "/:" );
   sb_host = SbString( newURL, nBeg, nEnd-1 );

   nBeg = nEnd;
   if( *(newURL+nBeg) == ':' && isdigit( *( newURL+nBeg+1 ) ) )
      port = atoi( newURL+nBeg+1 );
   else
      port = DEFAULT_PORT;

   nBeg = nBeg + strcspn( newURL+nBeg, "/" );
   sb_resource = SbString( newURL+nBeg );
   ACE_DEBUG(( LM_DEBUG, "prefix: %s\nhost: %s\nport: %d\nresource: %s\n",
	       sb_prefix.getString(),
	       sb_host.getString(),
	       port,
	       sb_resource.getString() ));
   return 1;
}

URL::
operator SbString( void ) const
{
   ACE_TRACE( "(URL::operator SbString)" );
   SbString url = sb_prefix;
   url += sb_host;
   char port_str[8];
   sprintf( port_str, ":%u", port );
   url += port_str;
   url += sb_resource;
   return url;
}
