/* $Id: URL.h,v 1.6 1997/09/25 20:32:06 remek Exp $ */
/*
 * File:       URL.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.6 $
 * Updated:    $Date: 1997/09/25 20:32:06 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef __URL_H
#define __URL_H

#include "Comm.h"

#include <string.h>
#include <iostream.h>
#include <stdlib.h>

class URL
{
   public:
      URL( const char* newURL );
      ~URL( void );
      int setURL( const char* newURL );
      const SbString& getPrefix( void ) const;
      const SbString& getHost( void ) const;
      const SbString& getResource( void ) const;
      unsigned int getPort( void ) const;
      operator const void* ( void ) const;
      operator SbString( void ) const;
      
   private:

      SbString sb_prefix;
      SbString sb_host;
      SbString sb_resource;
      unsigned int port;
      int intStatus;
      enum { DEFAULT_PORT=80 };
};

inline URL::
URL( const char* newURL )
{
   ACE_TRACE( "(URL::URL)" );
   intStatus = setURL( newURL );
}

inline URL::
~URL( void )
{
   ACE_TRACE( "(URL::~URL)" );
}

inline URL::
operator const void* ( void ) const
{
   ACE_TRACE( "(URL::operator const void*)" );
   return ( const void* )intStatus;
}

inline const SbString& URL::
getPrefix( void ) const
{
   ACE_TRACE( "(URL::getPrefix)" );
   return sb_prefix;
}

inline const SbString& URL::
getHost( void ) const
{
   ACE_TRACE( "(URL::getHost)" );
   return sb_host;
}

inline const SbString& URL::
getResource( void ) const
{
   ACE_TRACE( "(URL::getResourceName)" );
   return sb_resource;
}

inline unsigned int URL::
getPort( void ) const
{
   ACE_TRACE( "(URL::getPort)" );
   return port;
}

#endif

