/* $Id: ViewerMessage.h,v 1.4 1997/10/01 19:37:58 proman Exp $ */
/*
 * File         : ViewerMessage.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Tue Aug  5 18:29:22 1997
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1997/10/01 19:37:58 $
 * Copyright    : Northeast Parallel Architectures Center
 *                at Syracuse University 1997
 */

#ifndef _VIEWERMESSAGE_H
#define _VIEWERMESSAGE_H

#include "Message.h"
#include "Proto.h"
#include "SoXtWebViewer.h"

template<class HEADER>
class ViewerMessage
   : public Message<HEADER>
{
   public:
      ViewerMessage( const HEADER& hd, SoXtWebViewer* wv );
      HEADER::VID setVID( const HEADER::VID& );
      void checkVID( const HEADER& header );

   protected:
      SoXtWebViewer* viewer;
      bool change;
};

template<class HEADER>
inline ViewerMessage<HEADER>::
ViewerMessage( const HEADER& hd, SoXtWebViewer* wv )
   : Message<HEADER>( hd ), viewer( wv )
{
   ACE_TRACE( "(ViewerMessage::ViewerMessage)" );
}

template<class HEADER>
inline HEADER::VID ViewerMessage<HEADER>::
setVID( const HEADER::VID& vid )
{
   HEADER::VID old_vid = header.vID();
   header.setVID( vid );
   return old_vid;
}

template<class HEADER>
inline void ViewerMessage<HEADER>::
checkVID( const HEADER& header )
{
   ( header.vID() & viewer->getVID() ) ? ( change = true ) : ( change = false );
   ACE_DEBUG(( LM_DEBUG, "res: %d, change: %d\n", header.vID() & viewer->getVID(), change ));
}

#endif
