/* $Id: msgCSUPD.h,v 1.2 1997/09/25 20:32:12 remek Exp $ */
/*
 * File         : msgCSUPD.h
 * Author       : Pawel Roman
 * Created      : Tue Sep  2 15:40:12 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1997/09/25 20:32:12 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __MSGCSUPD_H
#define __MSGCSUPD_H

#include "SimEngMessage.h"
#include "SoMovingObj.h"

template<class HEADER>
class msgCSUPD
   : public SimEngMessage<HEADER>
{
   public:
      msgCSUPD( SoXtWebViewer* vw );
      void execute( void );

   private:
      char* name;
      SoMovingObj::Class cls;
};

template<class HEADER>
inline msgCSUPD<HEADER>::
msgCSUPD( SoXtWebViewer* vw )
   : SimEngMessage<HEADER>( Header( CSUPDATE, HEADER::BROADCAST ), vw )
{ 
   ACE_TRACE( "(msgCSUPD::msgCSUPD)" );
}

template<class HEADER>
inline void msgCSUPD<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgCSUPD::execute)" );
   if( change )
   {
      ACE_ASSERT( mb->size() > 1 );
      cls = ( SoMovingObj::Class )*mb->base();
      name = mb->base() + 1;
      ACE_DEBUG(( LM_DEBUG, "class: %d, name: %s\n", cls, name ));
      SoMovingObj* movo = viewer->getMovingObj( name );
      if( ! movo )
      {
	 ACE_ERROR(( LM_ERROR, "[!](msgCSUPD::execute) %s does not exist\n", name ));
	 return;
      }
      movo->update( cls );
   }
}

#endif

