/* $Id */
/*
 * File         : msgFOLLOW.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Tue Sep 23 12:03:41 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1997/09/25 20:32:12 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __MSGFOLLOW_H
#define __MSGFOLLOW_H


#include "SimEngMessage.h"

template<class HEADER>
class msgFOLLOW
   : public SimEngMessage<HEADER>
{
   public:
      msgFOLLOW( SoXtWebViewer* vw );
      void execute( void );

   private:
      char* name;
};

template<class HEADER>
inline msgFOLLOW<HEADER>::
msgFOLLOW( SoXtWebViewer* vw )
   : SimEngMessage<HEADER>( Header( ABFOLLOW, HEADER::BROADCAST ), vw )
{ 
   ACE_TRACE( "(msgFOLLOW::msgFOLLOW)" );
}

template<class HEADER>
inline void msgFOLLOW<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgFOLLOW::execute)" );
   if( change )
   {
      ACE_ASSERT( mb->size() > 1 );
      name = mb->base();
      ACE_DEBUG(( LM_DEBUG, "name: %s\n", name ));
      if( viewer->synchMode() )
	 viewer->followMovo( name );
   }
}

#endif

