/* $Id: msgHIDE.h,v 1.2 1997/09/25 20:32:13 remek Exp $ */
/*
 * File         : msgHIDE.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Fri Sep 12 14:50:08 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1997/09/25 20:32:13 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __MSGHIDE_H
#define __MSGHIDE_H


#include "SimEngMessage.h"
#include "SoMovingObj.h"

template<class HEADER>
class msgHIDE
   : public SimEngMessage<HEADER>
{
   public:
      msgHIDE( SoXtWebViewer* vw );
      void execute( void );

   private:
      char* name;
};

template<class HEADER>
inline msgHIDE<HEADER>::
msgHIDE( SoXtWebViewer* vw )
   : SimEngMessage<HEADER>( Header( ABHIDE, HEADER::BROADCAST ), vw )
{ 
   ACE_TRACE( "(msgHIDE::msgHIDE)" );
}

template<class HEADER>
inline void msgHIDE<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgHIDE::execute)" );
   if( change )
   {
      ACE_ASSERT( mb->size() > 1 );
      name = mb->base();
      ACE_DEBUG(( LM_DEBUG, "name: %s\n", name ));
      SoMovingObj* movo = viewer->getMovingObj( name );
      if( ! movo )
      {
	 ACE_ERROR(( LM_ERROR, "[!](msgHIDE::execute) %s does not exist\n", name ));
	 return;
      }
      movo->hide();
   }
}

#endif

