/* $Id: msgNAIRB.h,v 1.5 1997/09/25 20:32:13 remek Exp $ */
/*
 * File         : msgNAIRB.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Mon Aug 25 11:57:12 1997
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1997/09/25 20:32:13 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __MSGNAIRB_H
#define __MSGNAIRB_H

#include "SimEngMessage.h"
#include "SoMovingObj.h"

template<class HEADER>
class msgNAIRB
   : public SimEngMessage<HEADER>
{
   public:
      msgNAIRB( SoXtWebViewer* vw );
      void execute( void );

   private:
      char* name;
      char* desc;
      SoMovingObj::Type type;
};

template<class HEADER>
inline msgNAIRB<HEADER>::
msgNAIRB( SoXtWebViewer* vw )
   : SimEngMessage<HEADER>( Header( NEWAIRBORNE, HEADER::BROADCAST ), vw )
{ 
   ACE_TRACE( "(msgNAIRB::msgNAIRB)" );
}

template<class HEADER>
inline void msgNAIRB<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgNAIRB::execute)" );
   if( change )
   {
      ACE_HEX_DUMP(( LM_DEBUG, mb->base(), mb->size(), "NEWAIRBORNE" ));
      ACE_ASSERT( mb->size() > 1 );
      type = ( SoMovingObj::Type )*mb->base();
      name = mb->base() + 1;
      size_t name_len = strlen( name ) + 1;
      desc = name + name_len;
      ACE_DEBUG(( LM_DEBUG, "type: %d, name: %s, desc: %s\n", type, name, desc ));
      SoActiveTranslation* pos = new SoActiveTranslation;
      if( pos )
      {
	 if( *pos )
	 {
	    TRACE_REF( pos );
	    viewer->addMovingObj( new SoMovingObj( name, pos, type, viewer ) );
	    TRACE_UNREF( pos );
	 }
      }
      else
	 ACE_ERROR(( LM_ERROR, "[!](msgNAIRB::execute) No memory for pos\n" ));
   }
}

#endif

