/* $Id: msgNURL.h,v 1.10 1998/02/12 20:35:45 proman Exp $ */
/*
 * File:       msgNURL.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.10 $
 * Updated:    $Date: 1998/02/12 20:35:45 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef _MSGNURL_H
#define _MSGNURL_H

#include "ViewerMessage.h"
#include "Proto.h"

template<class HEADER>
class msgNURL : public ViewerMessage<HEADER>
{
   public:
      msgNURL( SoXtWebViewer* vw );
      MRESULT read( const SAP& sap, const Header& header );
      MRESULT write( const SAP& sap );
      MRESULT set( const void* params = NULL );
      void execute( void );
  
   private:
      char* newURL;
};

template<class HEADER>
inline msgNURL<HEADER>::
msgNURL( SoXtWebViewer* vw )
   : ViewerMessage<HEADER>( Header( NURL, HEADER::BROADCAST ), vw ), newURL( 0 )
{ 
   ACE_TRACE( "(msgNURL::msgNURL)" );
}

template<class HEADER>
inline msgNURL<HEADER>::MRESULT msgNURL<HEADER>::
read( const SAP& sap, const Header& header )
{
   ACE_TRACE( "(msgNURL::read)" );
   if( readMsg( sap, newURL, header.length() ) == OK_RES )
   {
      newURL[header.length()] = '\0';
      checkVID( header );
      return OK_RES;
   }
   else
      return END_RES;
}

template<class HEADER>
inline msgNURL<HEADER>::MRESULT msgNURL<HEADER>::
write( const SAP& sap ) 
{ 
   ACE_TRACE( "(msgNURL::write)" );
   header.setLength( strlen( viewer->getURL() ) );
   if( header.write( sap ) == Header::LINK_OK )
      if( sap.send_n( viewer->getURL(), header.length() ) == header.length() )
	 return OK_RES;
   
   return END_RES;
}

template<class HEADER>
inline msgNURL<HEADER>::MRESULT msgNURL<HEADER>::
set( const void* ) 
{ 
   ACE_TRACE( "(msgNURL::set)" );
   return FAIL_RES;
}

template<class HEADER>
inline void msgNURL<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgNURL::execute)" );
   if( change )
      viewer->loadNewGraph( newURL );

   TRACE_DELETE_TAB( newURL );
}

#endif
