/* $Id: msgSHOW.h,v 1.2 1997/09/25 20:32:16 remek Exp $ */
/*
 * File         : msgSHOW.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Fri Sep 12 14:49:56 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1997/09/25 20:32:16 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __MSGSHOW_H
#define __MSGSHOW_H

#include "SimEngMessage.h"
#include "SoMovingObj.h"

template<class HEADER>
class msgSHOW
   : public SimEngMessage<HEADER>
{
   public:
      msgSHOW( SoXtWebViewer* vw );
      void execute( void );

   private:
      char* name;
};

template<class HEADER>
inline msgSHOW<HEADER>::
msgSHOW( SoXtWebViewer* vw )
   : SimEngMessage<HEADER>( Header( ABSHOW, HEADER::BROADCAST ), vw )
{ 
   ACE_TRACE( "(msgSHOW::msgSHOW)" );
}

template<class HEADER>
inline void msgSHOW<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgSHOW::execute)" );
   if( change )
   {
      ACE_ASSERT( mb->size() > 1 );
      name = mb->base();
      ACE_DEBUG(( LM_DEBUG, "name: %s\n", name ));
      SoMovingObj* movo = viewer->getMovingObj( name );
      if( ! movo )
      {
	 ACE_ERROR(( LM_ERROR, "[!](msgSHOW::execute) %s does not exist\n", name ));
	 return;
      }
      movo->show();
   }
}

#endif

