/* $Id: msgSLAY.h,v 1.6 1997/09/25 20:32:17 remek Exp $ */
/*
 * File:       msgSLAY.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    long time ago
 * Revision:   $Revision: 1.6 $
 * Updated:    $Date: 1997/09/25 20:32:17 $
 * Copyright 1996/7 NPAC, Syracuse University
 *
 */

#ifndef _MSGSLAY_H
#define _MSGSLAY_H

#include "ViewerMessage.h"
#include "Proto.h"

template<class HEADER>
class msgSLAY : public ViewerMessage<HEADER>
{
   public:
      msgSLAY( SoXtWebViewer* vw );
      MRESULT read( const SAP& sap, const Header& header );
      MRESULT write( const SAP& sap );
      MRESULT set( const void* params = NULL );
      void execute( void );
  
   private:
      LayerCode layer;
};

template<class HEADER>
inline msgSLAY<HEADER>::
msgSLAY( SoXtWebViewer* vw )
   : ViewerMessage<HEADER>( Header( SLAY, vw->getVID(), sizeof layer ), vw )
{ 
   ACE_TRACE( "(msgSLAY::msgSLAY)" );
}

template<class HEADER>
inline msgSLAY<HEADER>::MRESULT msgSLAY<HEADER>::
read( const SAP& sap, const Header& header )
{
   ACE_TRACE( "(msgSLAY::read)" );
   if( sap.recv_n( &layer, sizeof layer ) == header.length() )
   {
      checkVID( header );
      return OK_RES;
   }
   else
      return END_RES;
}

template<class HEADER>
inline msgSLAY<HEADER>::MRESULT msgSLAY<HEADER>::
write( const SAP& sap ) 
{ 
   ACE_TRACE( "(msgSLAY::write)" );
   if( header.write( sap ) == Header::LINK_OK )
      if( sap.send_n( &viewer->getLayer(), sizeof layer ) == header.length() )
	 return OK_RES;
   
   return END_RES;
}

template<class HEADER>
inline msgSLAY<HEADER>::MRESULT msgSLAY<HEADER>::
set( const void* layer_buf ) 
{ 
   ACE_TRACE( "(msgSLAY::set)" );
   layer = *( int* )layer_buf;
   return OK_RES;
}

template<class HEADER>
inline void msgSLAY<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgSLAY::execute)" );
   if( change )
      viewer->switchLayerTo( layer );
}

#endif
